note
  description : "Objects represent complex numbers"
  author : "Gunnar Gotshalks"
  date : "2011 May 28"

class COMPLEX_NUMBER_REF

create make

--------------------------------------------------------------------------------
feature {NONE} -- Creation

make(the_real_part, the_imag_part : REAL)
  do
    real_part := the_real_part
    imag_part := the_imag_part
  ensure
    data_set: real_part = the_real_part
          and imag_part = the_imag_part
  end

--------------------------------------------------------------------------------
feature -- Queries

real_part: REAL
imag_part: REAL

--------------------------------------------------------------------------------
feature -- Operations

set_real (new_real_part : REAL)
  do
    real_part := new_real_part
  ensure
    data_set: real_part = new_real_part
  end

--------------------------------------------------------------------------------
feature -- Conversion

to_string : STRING
  do
    Result := real_part.out + " + " + imag_part.out + "i"
  end

end
